---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by markg.
--- DateTime: 16/06/2021 10:13
---
local SCRIPT_HANDLER = MasterCore.SCRIPT_HANDLER
local FRAME_TYPE = MasterCore.FRAME_TYPE

local EventController, super = MasterCore.Class:Create("EventController")
local frame = CreateFrame(FRAME_TYPE.FRAME)
MasterCore.EventController = EventController

function RegisterEventsForControllers(...)
    local eventControllers = { ... }
    local registeredEvents = {}

    for _, eventController in ipairs(eventControllers) do
        for _, event in ipairs(eventController.events) do
            if registeredEvents[event] == nil then
                registeredEvents[event] = true
                frame:RegisterEvent(event)
            end
        end
    end

    frame:SetScript(SCRIPT_HANDLER.ON_EVENT, function(_, ...)
        for _, eventController in ipairs(eventControllers) do
            eventController:OnEvent(...)
        end
    end)
end

function EventController:Init(events, messages)
    self = super.Init(self)
    self.events = events
    self.messages = messages
    return self
end

function EventController:OnEvent(event, ...)
end

function EventController:OnMessage(message, ...)
end

function EventController:SendMessgage(message, ...)
end
