-----
----- Generated by EmmyLua(https://github.com/EmmyLua)
----- Created by markg.
----- DateTime: 22/06/2021 08:12
-----

local t1 = { key = 2 }
local t2 = { 1, 2, t1 }
local t3 = { t1 = t1, t2 = t2 }

local isArray, makePrintString
isArray = function(table)
    return next(table) == nil or #table > 0
end

function Print(...)
    local args = { ... }
    local output = ""
    for _, v in ipairs(args) do
        output = output .. "\n" .. makePrintString(v)
    end

    print(output)
end

makePrintString = function(value, indents, isKV)
    indents = indents or ""
    if type(value) ~= "table" then
        if isKV then
            return value
        end

        return indents .. value
    end

    if next(value) == nil then
        if isKV then
            return "{ }"
        end
        return indents .. "{ }"
    end

    local output = ""
    local elIndents = indents .. "   "
    if isKV then
        output = "{\n"
    else
        output = indents .. "{\n"
    end

    if isArray(value) then
        for _, v in ipairs(value) do
            output = output .. makePrintString(v, elIndents) .. ",\n"
        end
    else
        for k, v in pairs(value) do
            output = output .. elIndents .. k .. " = " .. makePrintString(v, elIndents, true) .. ",\n"
        end
    end

    return output .. indents .. "}"
end
Print(t1, t2)
