---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by markg.
--- DateTime: 18/06/2021 21:22
---
local L = LibStub("AceLocale-3.0"):GetLocale(MASTER_PREPARE_NAME)
local FWBuyConfig = MasterPrepare.FWBuyConfig
local FWSellConfig = MasterPrepare.FWSellConfig
local FWActionButtonConfig = MasterPrepare.FWActionButtonConfig
local FW_TYPE = MasterPrepare.FW_TYPE

local FWConfig, super = MasterCore.Class:Create("FWConfig", MasterCore.Config)
MasterPrepare.FWConfig = FWConfig
function FWConfig:Init(type, db, order)
    self = super.Init(self, db[type], order)
    self.type = type

    if self.type == FW_TYPE.FOOD then
        self.name = L["Food"]
    end

    if self.type == FW_TYPE.WATER then
        self.name = L["Water"]
    end

    self.buy = FWBuyConfig:Init(type, self.db.buy, 1)
    self.sell = FWSellConfig:Init(type, self.db.sell, 2)
    self.actionButton = FWActionButtonConfig:Init(type, self.db.actionButton, 3)
    return self
end

function FWConfig:GetOptions()
    local itemName, stat
    if self.type == FW_TYPE.FOOD then
        itemName = "food"
        stat = "Health Point"
    end

    if self.type == FW_TYPE.WATER then
        itemName = "water"
        stat = "Mana Point"
    end

    return {
        name = self.name,
        type = 'group',
        childGroups = "tab",
        handler = self,
        order = self.order,
        args = {
            buy = self.buy:GetOptions(),
            sell = self.sell:GetOptions(),
            actionButton = self.actionButton:GetOptions(),
        }
    }
end

function FWConfig:GetDefaults()
    return {
        buy = FWBuyConfig:GetDefaults(),
        sell = FWSellConfig:GetDefaults(),
        actionButton = FWActionButtonConfig:GetDefaults(),
    }
end

