---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by markg.
--- DateTime: 20/06/2021 13:37
---
local L = LibStub("AceLocale-3.0"):GetLocale(MASTER_PREPARE_NAME)

local GearRepairConfig, super = MasterCore.Class:Create("GearRepairConfig", MasterCore.Config)
MasterPrepare.GearRepairConfig = GearRepairConfig

function GearRepairConfig:Init(db, order)
    self = super.Init(self, db, order)
    self.name = "Repair"
    return self
end

function GearRepairConfig:GetOptions()
    return {
        name = self.name,
        type = 'group',
        handler = self,
        order = self.order,
        args = {
            info = {
                order = self:_AutoIncrementOrder(true),
                type = "description",
                name = "Auto repair all items in Bags and Inventory",
                width = "full"
            },
            space1 = {
                order = self:_AutoIncrementOrder(),
                type = "description",
                name = "\n\n",
                width = "full"
            },
            enable = {
                order = self:_AutoIncrementOrder(),
                type = "toggle",
                name = "Enable",
                width = "full",
                set = "Set",
                get = "GetEnable"
            },
            warningInventoryOnly = {
                order = self:_AutoIncrementOrder(),
                type = "toggle",
                name = "Only warning on Inventory durability",
                width = "full",
                set = "Set",
                get = "GetWarningInventoryOnly",
                disabled = function()
                    return not self:GetEnable()
                end
            },
            minDurability = {
                order = self:_AutoIncrementOrder(),
                type = "range",
                name = "Min Durability (%)",
                desc = "Warning when overall durability lower than this value",
                min = 0,
                max = 100,
                step = 1,
                set = "Set",
                get = "GetMinDurability",
                disabled = function()
                    return not self:GetEnable()
                end
            },
        }
    }
end

function GearRepairConfig:GetEnable()
    return self:Get("enable")
end

function GearRepairConfig:GetMinDurability()
    return self:Get("minDurability")
end

function GearRepairConfig:GetWarningInventoryOnly()
    return self:Get("warningInventoryOnly")
end


function GearRepairConfig:GetDefaults()
    return {
        enable = true,
        minDurability = 50,
        warningInventoryOnly = false,
    }
end
