---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by markg.
--- DateTime: 20/06/2021 13:37
---
local L = LibStub("AceLocale-3.0"):GetLocale(MASTER_PREPARE_NAME)
local ITEM_QUALITY = MasterCore.ITEM_QUALITY

local GearSellConfig, super = MasterCore.Class:Create("GearSellConfig", MasterCore.Config)
MasterPrepare.GearSellConfig = GearSellConfig

function GearSellConfig:Init(db, order)
    self = super.Init(self, db, order)
    self.name = "Sell"
    return self
end

function GearSellConfig:GetOptions()
    return {
        name = self.name,
        type = 'group',
        handler = self,
        order = self.order,
        args = {
            intro = {
                order = self:_AutoIncrementOrder(true),
                type = "description",
                name = "Auto sell all junk items in Bags",
                width = "full"
            },
            space2 = {
                order = self:_AutoIncrementOrder(),
                type = "description",
                name = "\n\n",
                width = "full"
            },
            enable = {
                order = self:_AutoIncrementOrder(),
                type = "toggle",
                name = "Enable",
                width = "full",
                set = "Set",
                get = "GetEnable"
            },
            qualityThreshold = {
                order = self:_AutoIncrementOrder(),
                type = "select",
                values = self:GetQualities(),
                name = "Quality Threshold",
                width = "full",
                set = "Set",
                get = "GetQualityThreshold"
            },
        }
    }
end

function GearSellConfig:GetEnable()
    return self:Get("enable")
end

function GearSellConfig:GetQualityThreshold()
    return self:Get("qualityThreshold")
end

function GearSellConfig:GetDefaults()
    return {
        enable = true,
        qualityThreshold = ITEM_QUALITY.POOR
    }
end

function GearSellConfig:GetQualities()
    return {
        [ITEM_QUALITY.POOR] = "|c"..GetItemQualityHexColor(ITEM_QUALITY.POOR).."Poor",
        [ITEM_QUALITY.COMMON] = "|c"..GetItemQualityHexColor(ITEM_QUALITY.COMMON).."Common",
        [ITEM_QUALITY.UNCOMMON] = "|c"..GetItemQualityHexColor(ITEM_QUALITY.UNCOMMON).."Uncommon"
    }
end
