---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by markg.
--- DateTime: 21/06/2021 22:20
---
local EVENT = MasterCore.EVENT.BAG_UPDATE
local ContainerItemInfo = MasterCore.ContainerItemInfo
local Config = MasterPrepare.Config
local FW_TYPE = MasterPrepare.FW_TYPE
local MESSAGE = MasterPrepare.MESSAGE
local FWSerivce = MasterPrepare.FWService

local ActionButtonController, super = MasterCore.Class:Create("ActionButtonController", MasterCore.EventController)
MasterPrepare.ActionButtonController = ActionButtonController

function ActionButtonController:Init(type)
    self = super.Init(self, {
        EVENT.BAG_UPDATE
    })

    self.type = type
    return self
end

function ActionButtonController:OnMessage(message, food, water)
    if message == MESSAGE.PREPRATION_CHECKED then
        if self.type == FW_TYPE.FOOD then
            self.prepration = food
            self.config = Config.food.actionButton
        end

        if self.type == FW_TYPE.WATER then
            self.prepration = water
            self.config = Config.water.actionButton
        end

        if self.type == FW_TYPE.HEALING_POTION then
            self.prepration = FWSerivce:Init(FW_TYPE.HEALING_POTION)
            self.config = Config.potion.healing.actionButton
        end

        if self.type == FW_TYPE.MANA_POTION then
            self.prepration = FWSerivce:Init(FW_TYPE.MANA_POTION)
            self.config = Config.potion.mana.actionButton
        end

        self:_Check()
    end
end
function ActionButtonController:_Check()
    local key = self.config:GetKey()
    if key == nil then
        return
    end

    local actionSlot = GetActionSlot(key)
    if not actionSlot then
        return
    end

    local _, itemID = GetActionInfo(actionSlot)

    if self.actionItem == nil then
        self.actionItem = self.prepration:FindItemToUse()

        if self.actionItem then
            self:_Swap(self.actionItem, actionSlot)
        end
        return
    end

    -- Re-swap when action item was removed from this slot
    if itemID ~= self.actionItem.id then
        self:_Swap(self.actionItem, actionSlot)
    end

    -- Stop when action item still in stock
    -- Find a item to use
    local newActionItem = self.prepration:FindItemToUse()
    if newActionItem.id == self.actionItem.id then
        return
    end

    self.actionItem = newActionItem
    if self.actionItem then
        self:_Swap(self.actionItem, actionSlot)
    end

end

function ActionButtonController:_Swap(item, actionSlot)
    PickupContainerItem(item.bag, item.slot)
    PlaceAction(actionSlot)
    PutItemInBackpack()
end
