---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by markg.
--- DateTime: 20/06/2021 00:30
---
local ContainerItemInfo = MasterCore.ContainerItemInfo
local ItemInfo = MasterCore.ItemInfo
local Config = MasterPrepare.Config
local ITEM_TYPE = MasterCore.ITEM_TYPE
local ITEM_QUALITY = MasterCore.ITEM_QUALITY

local GearSellService, super = MasterCore.Class:Create("GearSellService")
MasterPrepare.GearSellService = GearSellService

function GearSellService:Init()
    self = super.Init(self)
    self.items = {}
    self.count = 0
    self.needed = false
    return self
end
function GearSellService:Check()
    self.items, self.count = self:_GetJunkItemsInBags()
    self.needed = self.count > 0
    return not self.needed
end

function GearSellService:_GetJunkItemsInBags()
    local junkItems = {}
    local count = 0
    for bag = 0, NUM_BAG_SLOTS do
        local numSlots = GetContainerNumSlots(bag)
        if numSlots > 0 then
            for slot = 1, numSlots do
                local containerItemInfo = ContainerItemInfo:Init(bag, slot)

                -- Checking item quality threshold
                if containerItemInfo.quality and containerItemInfo.quality <= Config.gear.sell:GetQualityThreshold() then
                    local itemID = GetContainerItemID(bag, slot)
                    local item = ItemInfo:Init(itemID)

                    if itemID and self:_IsSellable(item, containerItemInfo.quality) then
                        junkItems[itemID] = true
                        count = count + 1
                    end
                end
            end
        end
    end

    return junkItems, count
end

function GearSellService:_IsSellable(item, quality)
    if item.sellPrice == nil or item.sellPrice == 0 then
        return false
    end

    if quality >= ITEM_QUALITY.COMMON and item.type ~= ITEM_TYPE.ARMOR and item.type ~= ITEM_TYPE.WEAPON then
        return false
    end

    return true
end
